changeUnlockModeEvent = {};
changeUnlockModeEvent_mt = Class(changeUnlockModeEvent, Event);

InitEventClass(changeUnlockModeEvent, "changeUnlockModeEvent");

function changeUnlockModeEvent:emptyNew()
    local self = Event:new(changeUnlockModeEvent_mt);
    self.className = "changeUnlockModeEvent";
	
    return self;
end;

function changeUnlockModeEvent:new(object, unlockMode)
    local self = changeUnlockModeEvent:emptyNew()
    self.object = object;
	self.unlockMode = unlockMode;
	
    return self;
end;

function changeUnlockModeEvent:readStream(streamId, connection)
    self.object = networkGetObject(streamReadInt32(streamId));
	self.unlockMode = streamReadUIntN(streamId, 2);
	
    self:run(connection);
end;

function changeUnlockModeEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteUIntN(streamId, self.unlockMode, 2);
end;

function changeUnlockModeEvent:run(connection)
	self.object:changeUnlockMode(self.unlockMode, true);
	
	if not connection:getIsServer() then
		g_server:broadcastEvent(changeUnlockModeEvent:new(self.object, self.unlockMode), nil, connection, self.object);
	end;
end;

function changeUnlockModeEvent.sendEvent(object, unlockMode, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(changeUnlockModeEvent:new(object, unlockMode), nil, nil, object);
		else
			g_client:getServerConnection():sendEvent(changeUnlockModeEvent:new(object, unlockMode));
		end;
	end;
end;

setGoosAnimationEvent = {};
setGoosAnimationEvent_mt = Class(setGoosAnimationEvent, Event);

InitEventClass(setGoosAnimationEvent, "setGoosAnimationEvent");

function setGoosAnimationEvent:emptyNew()
    local self = Event:new(setGoosAnimationEvent_mt);
    self.className = "setGoosAnimationEvent";
	
    return self;
end;

function setGoosAnimationEvent:new(object, bool)
    local self = setGoosAnimationEvent:emptyNew()
    self.object = object;
	self.bool = bool;
	
    return self;
end;

function setGoosAnimationEvent:readStream(streamId, connection)
    self.object = networkGetObject(streamReadInt32(streamId));
	self.bool = streamReadBool(streamId);
	
    self:run(connection);
end;

function setGoosAnimationEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.bool);
end;

function setGoosAnimationEvent:run(connection)
	self.object:setGoosAnimation(self.bool, true);
	
	if not connection:getIsServer() then
		g_server:broadcastEvent(setGoosAnimationEvent:new(self.object, self.bool), nil, connection, self.object);
	end;
end;

function setGoosAnimationEvent.sendEvent(object, bool, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(setGoosAnimationEvent:new(object, bool), nil, nil, object);
		else
			g_client:getServerConnection():sendEvent(setGoosAnimationEvent:new(object, bool));
		end;
	end;
end;

setRideHeightEvent = {};
setRideHeightEvent_mt = Class(setRideHeightEvent, Event);

InitEventClass(setRideHeightEvent, "setRideHeightEvent");

function setRideHeightEvent:emptyNew()
    local self = Event:new(setRideHeightEvent_mt);
    self.className = "setRideHeightEvent";
	
    return self;
end;

function setRideHeightEvent:new(object, id, forceLimit)
    local self = setRideHeightEvent:emptyNew()
    self.object = object;
	self.id = id;
	self.forceLimit = forceLimit;
	
    return self;
end;

function setRideHeightEvent:readStream(streamId, connection)
    self.object = networkGetObject(streamReadInt32(streamId));
	self.id = streamReadInt8(streamId);
	if self.forceLimit ~= nil then
		self.forceLimit = streamReadBool(streamId);
	end;
	
    self:run(connection);
end;

function setRideHeightEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteInt8(streamId, self.id);
	if self.forceLimit ~= nil then
		streamWriteBool(streamId, self.forceLimit);
	end;
end;

function setRideHeightEvent:run(connection)
	self.object:setRideHeight(self.id, true, self.forceLimit);
	
	if not connection:getIsServer() then
		g_server:broadcastEvent(setRideHeightEvent:new(self.object, self.id, self.forceLimit), nil, connection, self.object);
	end;
end;

function setRideHeightEvent.sendEvent(object, id, forceLimit, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(setRideHeightEvent:new(object, id, forceLimit), nil, nil, object);
		else
			g_client:getServerConnection():sendEvent(setRideHeightEvent:new(object, id, forceLimit));
		end;
	end;
end;